Program Na_pripravu_davky_pro_ps2pk;

type PSize=^TSize;
     TSize=record
        Size:word;
        Next:PSize
     end;

var pc:byte;
    res,i,pomnum:word;
    pomstr:string[8];
    dd:boolean;
    Sizes,ps:PSize;
    code:integer;
    outsize:real;
    options:string;
    pfbname,pkname:string[12];
    f:text;

procedure SayHow;
begin
  Writeln;
  Writeln('Program sets up batch file for generating pk files');
  Writeln('in required sizes and resolution for ps2pk');
  Writeln('Usage:');
  Writeln('mkpsf PFB_name PK_name [-d] [-r Target resolution] [-s Sizes]');
  Writeln;
  Writeln('PFB_name is PFB and AFM name, must be same.');
  Writeln('PK_name is name in psfonts.map generating by afm2tfm');
  Writeln('Both names include without extensions');
  Writeln('Default target resolutin is 300 DPI');
  Writeln('Default Size is 10pt');
  Writeln('Switch -d allows Sizes in didots');
  Writeln('For generating create psres.dpr database by mkpsres!');
  Writeln;
  Writeln('Example: mkpsf times rtimes -d -r 300 -s 10 12 14 17');
  Halt(1)
end;

procedure Exitus(S:string);
begin
  Writeln(S);
  Halt(2)
end;

procedure ChangeResolution;
begin
 inc(i);
 pomstr:=Paramstr(i);
 Val(pomstr,pomnum,code);
 if code<>0 then Exitus('Bad resolution: ' + pomstr)
 else res:=pomnum
end;

procedure AddSizes;
var pp:PSize;
begin
  repeat
    inc(i);
    pomstr:=Paramstr(i);
    Val(pomstr,pomnum,code);
    if code<>0 then Exitus('Bad size ' + pomstr);
    if Sizes=nil then begin New(Sizes);
                            Sizes^.Size:=pomnum;
                            Sizes^.Next:=nil;
                            pp:=Sizes
                      end
    else begin while pp^.next <> nil do pp:=pp^.next;
               new(pp^.next);
               pp:=pp^.next;
               pp^.size:=pomnum;
               pp^.next:=nil
         end
  until i=pc
end;

begin
  Writeln('This is mkpsf 1.0');
  if ParamCount<1 then SayHow;
  dd:=false; res:=300; Sizes:=nil; i:=0; pc:=ParamCount;
  inc(i); pomstr:=ParamStr(i); pfbname:=pomstr;
  inc(i); pomstr:=ParamStr(i); pkname:=pomstr;
  while i<>pc do begin
    inc(i);
    pomstr:=ParamStr(i);
    if pomstr='-d' then dd:=true
    else if pomstr='-r' then ChangeResolution
         else if pomstr='-s' then AddSizes
              else Exitus('Bad parameter: ' + pomstr);
  end;

  if Sizes=nil then begin New(Sizes);
                          Sizes^.Size:=10;
                          Sizes^.Next:=nil
                    end;

  Assign(f,pkname+'.bat');
  Rewrite(f);
  writeln(f,'echo This batch is made by mkpsf with command line:');
  write(f,'echo'); for i:=0 to ParamCount do write(f,' ',ParamStr(i)); writeln(f);
  ps:=Sizes; writeln(f);
  while ps<>nil do begin
    outsize:=ps^.Size;
    if dd then outsize:=outsize*1.070008643;
    writeln(f,'ps2pk -X',res,' -Y',res,' -P',outsize:10:5,' ',pfbname,'.pfb ',pkname,'.',trunc(res*(outsize/10)));
    ps:=ps^.next;
    write('.')
  end;
  Close(f);
  Writeln(' Done');Writeln('Run ',pkname,'.bat file to generate your fonts.');
  Dispose(Sizes)
end.