Program Na_pripravu_davky_pro_ttf2pk;

type PSize=^TSize;
     TSize=record
        Size:word;
        Next:PSize
     end;

var pc:byte;
    res,i,pomnum:word;
    pomstr:string[8];
    dd:boolean;
    Sizes,ps:PSize;
    code:integer;
    outres:real;
    fontname:string[12];
    f:text;

procedure SayHow;
begin
  Writeln;
  Writeln('Program sets up batch file for generating pk files');
  Writeln('in required sizes and resolution for ttf2pk');
  Writeln('Usage:');
  Writeln('mkttf [Fontname] [-d] [-r Target resolution] [-s Sizes]');
  Writeln;
  Writeln('Fontname is name in ttfonts.map generating by ttf2tfm');
  Writeln('Default target resolutin is 300 DPI');
  Writeln('Default Size is 10pt');
  Writeln('Switch -d allows Sizes in didots');
  Writeln;
  Writeln('Example: mkttf arial -d -r 300 -s 10 12 14 17');
  Halt(1);
end;

procedure Exitus(S:string);
begin
  Writeln(S);
  Halt(1)
end;

procedure ChangeResolution;
begin
 inc(i);
 pomstr:=Paramstr(i);
 Val(pomstr,pomnum,code);
 if code<>0 then Exitus('Bad resolution: ' + pomstr)
 else res:=pomnum
end;

procedure AddSizes;
var pp:PSize;
begin
  repeat
    inc(i);
    pomstr:=Paramstr(i);
    Val(pomstr,pomnum,code);
    if code<>0 then Exitus('Bad size ' + pomstr);
    if Sizes=nil then begin New(Sizes);
                            Sizes^.Size:=pomnum;
                            Sizes^.Next:=nil;
                            pp:=Sizes;
                      end
    else begin while pp^.next <> nil do pp:=pp^.next;
               new(pp^.next);
               pp:=pp^.next;
               pp^.size:=pomnum;
               pp^.next:=nil
         end
  until i=pc;
end;


begin
  Writeln('This is mkttf 1.0');
  if ParamCount<1 then SayHow;
  dd:=false; res:=300; Sizes:=nil; i:=0; pc:=ParamCount;
  inc(i);
  pomstr:=ParamStr(i);
  fontname:=pomstr;
  while i<>pc do begin
    inc(i);
    pomstr:=ParamStr(i);
    if pomstr='-d' then dd:=true
    else if pomstr='-r' then ChangeResolution
         else if pomstr='-s' then AddSizes
              else Exitus('Bad parameter: ' + pomstr);
  end;

  if Sizes=nil then begin New(Sizes);
                          Sizes^.Size:=10;
                          Sizes^.Next:=nil
                    end;

  Assign(f,fontname+'.bat');
  Rewrite(f);
  writeln(f,'echo This batch is made by mkttf with command line:');
  write(f,'echo'); for i:=0 to ParamCount do write(f,' ',ParamStr(i)); writeln(f);
  ps:=Sizes; writeln(f);
  while ps<>nil do begin
    outres:=ps^.Size / (10 / res );
    if dd then outres:=outres*1.070008643;
    writeln(f,'ttf2pk -q -n ',fontname,' ',outres:10:5);
    writeln(f,'move ',fontname,'.pk ',fontname,'.',trunc(outres));
    ps:=ps^.next;
    write('.')
  end;
  Close(f);
  Writeln(' Done');Writeln('Run ',fontname,'.bat file to generate your fonts.');
  Dispose(Sizes)
end.