Program Na_kopirovani_pk_do_prislusnych_adresaru;
uses Dos;
const prompt:boolean=false;
      quite:boolean=true;
type PPkfiles=^TPkfiles;
     TPkfiles=record
        Item:string;
        Res:string[3];
        Next:PPKfiles
     end;

var PKdir,pomstr:string;
    DirItem:SearchRec;
    DirList,Pom:PPkfiles;
    f:text;

procedure HowUse;
begin
Writeln;
writeln('This program copies PK files to its directories from current directory.');
writeln('CPF will make necessary directories if do not exist.');
writeln('You must specify directory path of pk file destiny.');
writeln;
writeln('Use: cpf [-q] pkdir');
writeln;
writeln('pkdir is directory of pk files ');
writeln('-q    will shut up');
writeln;
writeln('Example: cpf -q c:\emtex\fonts\pixel.lj');
writeln;
writeln('PK file must have extension as number, this number is DPI.');
writeln('For example: bodoni.385 or bookman.642');
writeln;
Halt(1)
end;

procedure AddItem(Somefile:string);
var P: PathStr; D: DirStr;
    N: NameStr; E: ExtStr;
    I,Code:integer;
    Pom:PPkfiles;
begin
 FSplit(Somefile, D, N, E);
 E:=E[2]+E[3]+E[4];
 if E[1] <> '.' then begin Val(E, I, Code); { is this extension number? }
                       if code = 0 then begin
                         if DirList=nil then begin New(DirList);
                                                   DirList^.Item:=Somefile;
                                                   DirList^.Res:=E;
                                                   DirList^.Next:=nil
                                             end
                         else begin Pom:=DirList;
                                    while Pom^.Next<>nil do Pom:=Pom^.Next;
                                    New(Pom^.Next);
                                    Pom:=Pom^.Next;
                                    Pom^.Item:=SomeFile;
                                    Pom^.Res:=E;
                                    Pom^.Next:=nil
                              end;
                         if quite then writeln('Adding ... ',Somefile)
                       end
                       else if quite then writeln('Skipping ... ',SomeFile);
                 end
end;

function Existdir(SomeDir:PathStr):boolean;
var
 DirInfo: SearchRec;
begin
 FindFirst(SomeDir, Directory, DirInfo);
 Existdir:=DosError=0
end;

procedure Copyfile(Somefile:PathStr;Res:string);
var ResPKDir,Command:string;
begin
  ResPKDir:=PKDir+'\'+Res+'DPI';
  Command:='Copy '+Somefile+' '+ResPKDir+'\*.pk'+' > nul';
  if not Existdir(ResPKDir) then Writeln(f,'mkdir '+ResPKDir);
  Writeln(f, Command)
end;


begin
  writeln('This is CPF (Copy Pk Fonts) version 1.0'); DirList:=nil;
  if ParamCount=0 then HowUse;
  pomstr:=ParamStr(1);
  if pomstr='-q' then begin quite:=false;
                            pomstr:=ParamStr(2)
                      end;
  PKdir:=pomstr;
  if quite then write('Testing your PKdir: ',PKdir,' ...');
  if not Existdir(PKdir)then begin Writeln(' not OK');
                                   Writeln('Bad pkdir parameter: ',PkDir);
                                   HowUse
                             end
  else if quite then Writeln(' OK');
  if quite then writeln('Searching PK files ...');
  FindFirst('*.*', Archive, DirItem);
  while DosError = 0 do begin AddItem(DirItem.Name);
                              FindNext(DirItem)
                        end;
  if quite then writeln('Making !copy.bat ...');
  Assign(f,'!copy.bat');
  Rewrite(f);Writeln(f,'@echo off');
  Pom:=DirList;
  while Pom<>nil do begin Copyfile(Pom^.Item,Pom^.Res);
                          Pom:=Pom^.Next
                    end;
  Close(f);
  if quite then writeln('Making !smaz.bat ...');
  Assign(f,'!smaz.bat');
  Rewrite(f);Writeln(f,'@echo off');
  Pom:=DirList;
  while Pom<>nil do begin Writeln(f,'del ',Pom^.Item,' >nul');
                          Pom:=Pom^.Next
                    end;
  Close(f);
  if quite then writeln('For copying run !copy.bat and for deleting old PKs run !smaz.bat.');
  Writeln('... Done ...  Have a fun.');
  Dispose(DirList)
end.